; Eample program xram02.a51
; RAM Inspector
; by Chin-Shiuh Shieh
; 1999-10-25
;
; Pin Assignment
LCD_E   EQU     P2.6
LCD_RW  EQU     P2.5
LCD_RS  EQU     P2.4
;Memory Allocation
H_ADRS  EQU     00h
L_ADRS  EQU     01h
R_DATA  EQU     02h
BYTE    EQU     03h
;
	ORG	0000h
	JMP	START
;
;Interrupt Vector Table
	ORG	0003h
	RETI
	ORG	000Bh
	RETI
	ORG	0013h
	RETI
	ORG	001Bh
	RETI
;
	ORG	0030h
START:
        CALL    INIT_LCD
MENU:
        MOV     A,#01h
        CALL    PUT_IR
        MOV     DPTR,#M_WEL
        CALL    SHOW_STR
        MOV     A,#0C0h
        CALL    PUT_IR
        MOV     DPTR,#M_MENU
        CALL    SHOW_STR
        CALL    GET_KEY
        CJNE    A,#00h,READ
WRITE:
        MOV     A,#01h
        CALL    PUT_IR
        MOV     DPTR,#M_WR
        CALL    SHOW_STR
        MOV     A,#0C0h
        CALL    PUT_IR
        CALL    GET_ADDRESS
        MOV     A,#' '
        CALL    PUT_DR
        CALL    GET_DATA
        MOV     DPL,L_ADRS
        MOV     DPH,H_ADRS
        MOV     A,R_DATA
        MOVX    @DPTR,A
        MOV     P0,#0FFh
        MOV     DPTR,#M_OK
        CALL    SHOW_STR
        CALL    WAIT_BUTTON
        JMP     MENU
READ:
        CJNE    A,#01h,TEST
        MOV     A,#01h
        CALL    PUT_IR
        MOV     DPTR,#M_RD
        CALL    SHOW_STR
        MOV     A,#0C0h
        CALL    PUT_IR
        CALL    GET_ADDRESS
        MOV     DPL,L_ADRS
        MOV     DPH,H_ADRS
        MOVX    A,@DPTR
        MOV     R_DATA,A
        MOV     A,#' '
        CALL    PUT_DR
        MOV     A,#'D'
        CALL    PUT_DR
        MOV     A,#':'
        CALL    PUT_DR
        MOV     BYTE,R_DATA
        CALL    SHOW_BYTE
        MOV     DPTR,#M_OK
        CALL    SHOW_STR
        CALL    WAIT_BUTTON
        JMP     MENU
;
TEST:
        MOV     A,#01h
        CALL    PUT_IR
        MOV     DPTR,#M_TEST
        CALL    SHOW_STR
        MOV     H_ADRS,#00h
TEST0:
        MOV     L_ADRS,#00h
TEST1:
        MOV     A,#0C0h
        CALL    PUT_IR
        MOV     BYTE,H_ADRS
        CALL    SHOW_BYTE
        MOV     BYTE,L_ADRS
        CALL    SHOW_BYTE
        MOV     DPH,H_ADRS
        MOV     DPL,L_ADRS
        MOV     BYTE,#00
TEST2:  MOV     A,BYTE
        MOVX    @DPTR,A
        MOV     P0,#0FFh
        MOVX    A,@DPTR
        CJNE    A,BYTE,ERROR
        DJNZ    BYTE,TEST2
        INC     L_ADRS
        CJNE    R1,#00,TEST1
        INC     H_ADRS
        CJNE    R0,#08,TEST0
        MOV     DPTR,#M_OK
        CALL    SHOW_STR
        CALL    WAIT_BUTTON
        JMP     MENU
ERROR:
        MOV     DPTR,#M_ERROR
        CALL    SHOW_STR
        CALL    WAIT_BUTTON
        JMP     MENU
;
GET_KEY:	;Get a Key from Keypad
WAIT_KEY:
        JNB     P3.4,WAIT_KEY
        MOV     A,P3
        ANL     A,#0Fh
WAIT_KEY_RELEASE:
        JB      P3.4,WAIT_KEY_RELEASE
        RET

WAIT_BUTTON:
        JB      P3.5,WAIT_BUTTON
WAIT_BUTTON_RELEASE:
        JNB     P3.5,WAIT_BUTTON_RELEASE
        RET
;
WAIT_LCD:
        MOV     R7,A
        SETB    P2.7            ;Disable RAM
        MOV     P0,#0FFh        ;Reset P0 for Input
        CLR     LCD_RS
        SETB    LCD_RW
LCD_BUSY:
        SETB    LCD_E
        MOV     A,P0
        CLR     LCD_E
        JB      ACC.7,LCD_BUSY
        MOV     A,R7
        RET
;
PUT_IR:
        CALL    WAIT_LCD
        CLR     LCD_RS
        CLR     LCD_RW
        MOV     P0,A
        SETB    LCD_E
        CLR     LCD_E
        RET
;
PUT_DR:
        CALL    WAIT_LCD
        SETB    LCD_RS
        CLR     LCD_RW
        MOV     P0,A
        SETB    LCD_E
        CLR     LCD_E
        RET
;
INIT_LCD:
        CLR     LCD_E
        MOV     A,#00111000b
        CALL    PUT_IR
        MOV     A,#00001111b
        CALL    PUT_IR
        MOV     A,#00000110b
        CALL    PUT_IR
        MOV     A,#00000001b
        CALL    PUT_IR
        RET
;
GET_ADDRESS:
        MOV     A,#'A'
        CALL    PUT_DR
        MOV     A,#':'
        CALL    PUT_DR
        CALL    GET_BYTE
        MOV     H_ADRS,BYTE
        CALL    GET_BYTE
        MOV     L_ADRS,BYTE
        RET
;
GET_DATA:
        MOV     A,#'D'
        CALL    PUT_DR
        MOV     A,#':'
        CALL    PUT_DR
        CALL    GET_BYTE
        MOV     R_DATA,BYTE
        RET
;
GET_BYTE:
        MOV     BYTE,#00h
        CALL    GET_KEY
        MOV     R5,A
        CALL    SHOW_ASC
        MOV     A,R5
        ANL     A,#0Fh
        SWAP    A
        ORL     BYTE,A
        CALL    GET_KEY
        MOV     R5,A
        CALL    SHOW_ASC
        MOV     A,R5
        ANL     A,#0Fh
        ORL     BYTE,A
        RET
;
SHOW_BYTE:
        MOV     A,BYTE
        SWAP    A
        ANL     A,#0Fh
        CALL    SHOW_ASC
        MOV     A,BYTE
        ANL     A,#0Fh
        CALL    SHOW_ASC
        RET
;
SHOW_ASC:
        MOV     DPTR,#ASCII
        MOVC    A,@A+DPTR
        CALL    PUT_DR
        RET
ASCII:  DB      "0123456789ABCDEF"
;
SHOW_STR:
        MOV     A,#00h
        MOVC    A,@A+DPTR
        CJNE    A,#'$',SHOW_CHAR
        RET
SHOW_CHAR:
        CALL    PUT_DR
        INC     DPTR
        SJMP    SHOW_STR
M_WEL:  DB      "Welcome!$"
M_MENU: DB      "0)WR 1)RD *)Test$"
M_WR:   DB      "Write$"
M_RD:   DB      "Read$"
M_TEST: DB      "Test$"
M_OK:   DB      " OK!$"
M_ERROR:DB      " Error!$"
;
        END
